// libViewer Version 1.1
// includes extended Server Communication

package libViewer;

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

public class Main extends Applet {

    // global Variables in libViewer System
    static URL Codebase;
    static URL DocumentBase;

    static ActionList Actions;

    static int down_xpos   = 0;
    static int upper_xpos  = 0;
    static int prev_xpos   = 0;
    static int xpos        = 0;
    static int zoom_factor = 3;

    static int query_start = 0;

    static int start_node_xpos = 0;
    static int start_node_ypos = 0;
    static boolean scroll_right = false;

    static Image folder_template;
    static Image audio_template;
    static Image video_template;
    static Image sublibrary_template;
    static Image other_template;
    static Image software_template;
    static Image finger_li;
    static Image finger_re;
    static Image dust1;
    static Image dust2;
    static Image dust3;
    static Image dust4;
    static Image dust5;
    static Image welt;

    static Image AltaVistaLogo;

    static boolean Lib_loaded = false;
    static boolean not_on_repaint = true;
    static boolean Nodes_Rep = false;
    static AppletContext ac;

    // Controls
    DrawArea   Window;
    DrawAreaXY WindowXY;

    static Logos logos;

    Button func_1   = new Button();
    Button func_2   = new Button();
    Button previous = new Button();
    Button next     = new Button();
    Button up       = new Button();
    Button down     = new Button();
    Button left     = new Button();
    Button right    = new Button();
    Button PBSort   = new Button();

    Label  freemem             = new Label();
    Label  Label_Zoomfactor    = new Label();
    static Label  title        = new Label();
    static Label  description  = new Label();
    Label  title_label         = new Label();
    Label  description_label   = new Label();
    static Label server_status = new Label();
    static Label server_label  = new Label();
    Label  details             = new Label();
    Label  console_label       = new Label();

    static Details detail_window   = new Details();
    static Frame Console = new Frame();

    static Checkbox Checkbox1 = new Checkbox();
    static Checkbox Checkbox2 = new Checkbox();

    Choice Sort_Criteria = new Choice();
    Choice server_choice = new Choice();
    static Choice Zoomfactor    = new Choice();

    TextField data = new TextField();

    static TextArea StatusWindow;

    static ItemList itemlist;
    static ItemList itemlist_temp;
    static Map map;

//Construct the applet
public Main() {

}

//Initialize the applet
public void init() {
    try {
    jbInit();
    }
    catch (Exception e) {
    e.printStackTrace();
    }
}

private void jbInit() throws Exception {

    Codebase     = getCodeBase();
    DocumentBase = getDocumentBase();
    ac = getAppletContext();

    this.setLayout(null);
    this.setBackground(Color.lightGray);

    this.add(server_choice);
    server_choice.reshape(10, Settings.DRAWAREA_HEIGHT + 20,300,28);

    this.add(data);
    data.reshape(10, Settings.DRAWAREA_HEIGHT + 52,300,24);

    this.add(server_status);
    server_status.reshape(85, Settings.DRAWAREA_HEIGHT + 85,353,24);
    server_status.setText("");
    this.add(server_label);
    server_label.reshape(12, Settings.DRAWAREA_HEIGHT + 85,45,24);
    server_label.setText("Status:");

    this.add(title);
    title.reshape(85, Settings.DRAWAREA_HEIGHT + 105,353,24);
    title.setText("");
    this.add(title_label);
    title_label.reshape(12, Settings.DRAWAREA_HEIGHT + 105,45,24);
    title_label.setText("Title:");

    this.add(description);
    description.reshape(85, Settings.DRAWAREA_HEIGHT + 125,353,24);
    description.setText("");
    this.add(description_label);
    description_label.reshape(12, Settings.DRAWAREA_HEIGHT + 125,70,24);
    description_label.setText("Description:");

    this.add(func_1);
    func_1.reshape(320, Settings.DRAWAREA_HEIGHT + 20,120,24);

    this.add(func_2);
    func_2.reshape(320, Settings.DRAWAREA_HEIGHT + 52,120,24);


    this.add(Sort_Criteria);
    Sort_Criteria.reshape(450, Settings.DRAWAREA_HEIGHT + 20,120,28);
    Sort_Criteria.addItem("by Title");
    Sort_Criteria.addItem("by Creator");
    Sort_Criteria.addItem("by Publisher");
    Sort_Criteria.addItem("by Format");
    Sort_Criteria.addItem("by Type");
    Sort_Criteria.addItem("by Language");
    Sort_Criteria.addItem("by Domain");
    Sort_Criteria.addItem("by Byte-Size");
    Sort_Criteria.addItem("by Page-Size");
    Sort_Criteria.addItem("by Date");

    this.add(Label_Zoomfactor);
    Label_Zoomfactor.reshape(450, Settings.DRAWAREA_HEIGHT + 54, 40, 20);
    Label_Zoomfactor.setText("Zoom:");

    this.add(Zoomfactor);
    Zoomfactor.reshape(495, Settings.DRAWAREA_HEIGHT + 50, 75, 28);
    Zoomfactor.addItem("100%");
    Zoomfactor.addItem("33%");
    Zoomfactor.select("33%");

    this.add(PBSort);
    PBSort.reshape(580, Settings.DRAWAREA_HEIGHT + 20,120,24);
    PBSort.setLabel("Sort Library");

    this.add(previous);
    previous.reshape(580, Settings.DRAWAREA_HEIGHT + 52,55,20);
    previous.setLabel("< start");

    this.add(next);
    next.reshape(645, Settings.DRAWAREA_HEIGHT + 52,55,20);
    next.setLabel("next >");

    up.reshape(630, Settings.DRAWAREA_HEIGHT + 90,20,20);
    up.setLabel("up");

    down.reshape(630, Settings.DRAWAREA_HEIGHT + 130,20,20);
    down.setLabel("dn");

    left.reshape(600, Settings.DRAWAREA_HEIGHT + 110,20,20);
    left.setLabel("<");

    right.reshape(660, Settings.DRAWAREA_HEIGHT + 110,20,20);
    right.setLabel(">");

    if (Settings.MEM_WATCH_ON) {
        this.add(freemem);
        freemem.reshape(420, Settings.DRAWAREA_HEIGHT + 115,100,20); }

    detail_window.resize(Settings.DETAIL_WIN_WIDTH,Settings.DETAIL_WIN_HEIGHT);
    detail_window.setBackground(Color.lightGray);
    detail_window.setTitle("Detail Window");
    //detail_window.setLocation(700,50);

    this.add(details);
    details.reshape(475, Settings.DRAWAREA_HEIGHT + 90,100,20);
    details.setText("show details");
    this.add(Checkbox1);
    Checkbox1.reshape(450,Settings.DRAWAREA_HEIGHT + 90,20,20);

    this.add(console_label);
    console_label.reshape(475, Settings.DRAWAREA_HEIGHT + 112,100,20);
    console_label.setText("show console");
    this.add(Checkbox2);
    Checkbox2.reshape(450,Settings.DRAWAREA_HEIGHT + 112,20,20);

    Console.resize(Settings.CONSOLE_WIN_WIDTH, Settings.CONSOLE_WIN_HEIGHT);
    Console.setBackground(Color.lightGray);
    Console.setTitle("Console Window");

    StatusWindow = new TextArea();
    
    Console.add(StatusWindow);

    folder_template     = getImage(getDocumentBase(), Settings.FOLDER_TEMPLATE_FILENAME);
    audio_template      = getImage(getDocumentBase(), Settings.AUDIO_TEMPLATE_FILENAME);
    video_template      = getImage(getDocumentBase(), Settings.VIDEO_TEMPLATE_FILENAME);
    video_template      = getImage(getDocumentBase(), Settings.VIDEO_TEMPLATE_FILENAME);
    sublibrary_template = getImage(getDocumentBase(), Settings.SUBLIBRARY_TEMPLATE_FILENAME);
    software_template   = getImage(getDocumentBase(), Settings.SOFTWARE_TEMPLATE_FILENAME);
    other_template      = getImage(getDocumentBase(), Settings.OTHER_TEMPLATE_FILENAME);
    finger_li           = getImage(getDocumentBase(), Settings.FINGER_LI_FILENAME);
    finger_re           = getImage(getDocumentBase(), Settings.FINGER_RE_FILENAME);
    dust1               = getImage(getDocumentBase(), Settings.DUST1_FILENAME);
    dust2               = getImage(getDocumentBase(), Settings.DUST2_FILENAME);
    dust3               = getImage(getDocumentBase(), Settings.DUST3_FILENAME);
    dust4               = getImage(getDocumentBase(), Settings.DUST4_FILENAME);
    dust5               = getImage(getDocumentBase(), Settings.DUST5_FILENAME);
    AltaVistaLogo       = getImage(getDocumentBase(), Settings.ALTAVISTALOGO_FILENAME);
    welt                = getImage(getDocumentBase(), Settings.WELTKUGEL_FILENAME);

    loadLogos();

    Actions = new ActionList();
    PrefsLoader.readServerPrefs(StatusWindow, Actions);

    Actions.setupServerChoice(server_choice);
    Actions.selectAction(0,data,func_1,func_2);

}

//Get Applet information
public String getAppletInfo() {
    return "Applet Information";
}

public void prt (String text) {

  StatusWindow.appendText(text);

}

//Get parameter info
public String[][] getParameterInfo() {
    return null;
}
//------------------------------------------------------------------------------
public void loadLogos () {
    int i;
    logos = new Logos (StatusWindow);
    for (i=0; i < logos.number_rows; i++) {
        logos.row[i].Logo = getImage(getDocumentBase(), logos.row[i].Logo_Filename);
        }
}
//------------------------------------------------------------------------------
public void Zoom_in (int Key) {

  Zoomfactor.select("100%");

  if (itemlist.xy_params_valid) {
    int i,j,x;
    map = new Map (itemlist, StatusWindow);
    for (j = 0; j < map.y_dim; j++) {
       for (i = 0; i < map.x_dim; i++) {
          for (x = 0; x < map.nodes[i][j].number_elements; x++) {
               if (Key == map.nodes[i][j].elements[x].Key) {
                   start_node_xpos = i;
                   start_node_ypos = j;
               }
          }
       }
    }
  }
  else {
    int i=0;
    while (Key != itemlist.items[i].Key) { i++; }
    i = i - Settings.ZOOM_START_OFFSET;
    if (i < 0) i = 0;
    Main.down_xpos = i;
  }
  refreshWindow();
}
//------------------------------------------------------------------------------
public synchronized boolean handleEvent (Event evt) {
        //----------------------------------------------------------------------
        if (evt.id == 1)
        {
              Zoom_in(evt.key);
        }
        //----------------------------------------------------------------------
        if (evt.target == Zoomfactor && evt.id == Event.ACTION_EVENT)
        {

            if (Lib_loaded) {
                if (itemlist.xy_params_valid) {
                    map = new Map (itemlist, StatusWindow);
                    Nodes_Rep = true;
                }
                refreshWindow();
            }
        }
        //----------------------------------------------------------------------
        if (evt.target == func_1 && evt.id == Event.ACTION_EVENT)
        {
            Action currentAction = (Action) Actions.Items.elementAt(server_choice.getSelectedIndex());
            itemlist = new ItemList();
            itemlist =
            Networking.processRequest(currentAction.URL,
                                      currentAction.Port,
                                      currentAction.But1,
                                      data.getText(),
                                      currentAction.Reserved,
                                      Actions,
                                      server_choice,
                                      StatusWindow);
            if (itemlist.xy_params_valid) {
                map = new Map (itemlist, StatusWindow);
                Nodes_Rep = true;
                this.add(up);
                this.add(down);
                this.add(left);
                this.add(right);
                start_node_xpos = 0;
                start_node_ypos = 0;
                }
            down_xpos = 0;
            if (Lib_loaded) refreshWindow();

        }
        //----------------------------------------------------------------------
        if (evt.target == func_2 && evt.id == Event.ACTION_EVENT)
        {
            Action currentAction = (Action) Actions.Items.elementAt(server_choice.getSelectedIndex());
            itemlist = new ItemList();
            itemlist =
            Networking.processRequest(currentAction.URL,
                                      currentAction.Port,
                                      currentAction.But2,
                                      data.getText(),
                                      currentAction.Reserved,
                                      Actions,
                                      server_choice,
                                      StatusWindow);
            if (itemlist.xy_params_valid) {
                map = new Map (itemlist, StatusWindow);
                Nodes_Rep = true;
                this.add(up);
                this.add(down);
                this.add(left);
                this.add(right);
                start_node_xpos = 0;
                start_node_ypos = 0;
                }
            down_xpos = 0;
            if (Lib_loaded) refreshWindow();

        }
        //----------------------------------------------------------------------
        if (evt.target == server_choice && evt.id == Event.ACTION_EVENT)
        {
            Actions.selectAction(server_choice.getSelectedIndex(), data, func_1, func_2);
        }
        //----------------------------------------------------------------------
        if (evt.target == previous && evt.id == Event.ACTION_EVENT)
        {
                      if (Lib_loaded) {
                down_xpos = 0;
                refreshWindow(); }
        }
        //----------------------------------------------------------------------
        if (evt.target == up && evt.id == Event.ACTION_EVENT)
        {
            if (Lib_loaded) {
              start_node_ypos --;
              refreshWindow(); }
        }
        //----------------------------------------------------------------------
        if (evt.target == down && evt.id == Event.ACTION_EVENT)
        {
            if (Lib_loaded) {
              start_node_ypos ++;
              refreshWindow(); }
        }
        //----------------------------------------------------------------------
        if (evt.target == left && evt.id == Event.ACTION_EVENT)
        {
            if (Lib_loaded) {
              start_node_xpos --;
              refreshWindow(); }
        }
        //----------------------------------------------------------------------
        if (evt.target == right && evt.id == Event.ACTION_EVENT)
        {
            if (Lib_loaded) {
              start_node_xpos ++;
              refreshWindow(); }
        }
        //----------------------------------------------------------------------
        if (evt.target == Checkbox1 && evt.id == Event.ACTION_EVENT)
        {
            if (Checkbox1.getState()) detail_window.show();
            else detail_window.hide();
        }
        //----------------------------------------------------------------------
        if (evt.target == Checkbox2 && evt.id == Event.ACTION_EVENT)
        {
            if (Checkbox2.getState()) Console.show();
            else Console.hide();
        }
        //----------------------------------------------------------------------
        if (evt.target == next && evt.id == Event.ACTION_EVENT)
        {
            if (Lib_loaded) {
              down_xpos = upper_xpos + 1;
              scroll_right = true;
              refreshWindow(); }
        }
        //----------------------------------------------------------------------
        if (evt.target == PBSort && evt.id == Event.ACTION_EVENT)
        {
        if (Lib_loaded) {
            int i, j;
            ElementData help = null;
            server_status.setText("libViewer: Sorting Library, please wait...");
            for (i = itemlist.number_items - 1; i > 0; i--) {
                for (j = 0; j < i; j++) {
                    if (Sort_Criteria.getSelectedItem() == "by Title") {
                        if (itemlist.items[j].title.compareTo(itemlist.items[j+1].title) > 0) {
                        help = itemlist.items[j];
                        itemlist.items[j] = itemlist.items[j+1];
                        itemlist.items[j+1] = help; } }
                    if (Sort_Criteria.getSelectedItem() == "by Page-Size") {
                        if (itemlist.items[j].page_size > itemlist.items[j+1].page_size) {
                        help = itemlist.items[j];
                        itemlist.items[j] = itemlist.items[j+1];
                        itemlist.items[j+1] = help; } }
                    if (Sort_Criteria.getSelectedItem() == "by Byte-Size") {
                        if (itemlist.items[j].byte_size > itemlist.items[j+1].byte_size) {
                        help = itemlist.items[j];
                        itemlist.items[j] = itemlist.items[j+1];
                        itemlist.items[j+1] = help; } }
                    if (Sort_Criteria.getSelectedItem() == "by Date") {
                        Date date1 = new Date(itemlist.items[j].date);
                        Date date2 = new Date(itemlist.items[j+1].date);
                        if (date1.after(date2)) {
                        help = itemlist.items[j];
                        itemlist.items[j] = itemlist.items[j+1];
                        itemlist.items[j+1] = help; } }
                    if (Sort_Criteria.getSelectedItem() == "by Language") {
                        if (itemlist.items[j].language.compareTo(itemlist.items[j+1].language) > 0) {
                        help = itemlist.items[j];
                        itemlist.items[j] = itemlist.items[j+1];
                        itemlist.items[j+1] = help; } }
                    if (Sort_Criteria.getSelectedItem() == "by Domain") {
                        if (itemlist.items[j].domain.compareTo(itemlist.items[j+1].domain) > 0) {
                        help = itemlist.items[j];
                        itemlist.items[j] = itemlist.items[j+1];
                        itemlist.items[j+1] = help; } }
                    if (Sort_Criteria.getSelectedItem() == "by Creator") {
                        if (itemlist.items[j].creator.compareTo(itemlist.items[j+1].creator) > 0) {
                        help = itemlist.items[j];
                        itemlist.items[j] = itemlist.items[j+1];
                        itemlist.items[j+1] = help; } }
                    if (Sort_Criteria.getSelectedItem() == "by Publisher") {
                        if (itemlist.items[j].publisher.compareTo(itemlist.items[j+1].publisher) > 0) {
                        help = itemlist.items[j];
                        itemlist.items[j] = itemlist.items[j+1];
                        itemlist.items[j+1] = help; } }
                    if (Sort_Criteria.getSelectedItem() == "by Format") {
                        if (itemlist.items[j].format.compareTo(itemlist.items[j+1].format) > 0) {
                        help = itemlist.items[j];
                        itemlist.items[j] = itemlist.items[j+1];
                        itemlist.items[j+1] = help; } }
                    if (Sort_Criteria.getSelectedItem() == "by Type") {
                        if (itemlist.items[j].type.compareTo(itemlist.items[j+1].type) > 0) {
                        help = itemlist.items[j];
                        itemlist.items[j] = itemlist.items[j+1];
                        itemlist.items[j+1] = help; } }
                    }
            }
            server_status.setText("libViewer: done.");
            down_xpos = 0;
            refreshWindow();
        }
        } 
        return super.handleEvent(evt);

}

public void refreshWindow () {
    Main.not_on_repaint = true;
    if (Window != null) {Window.removeAll();remove(Window);}
    if (WindowXY != null) {WindowXY.removeAll();remove(WindowXY);}
    freemem.setText("used: " + (Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory()));
    if (Nodes_Rep) {
        WindowXY = new DrawAreaXY(map, StatusWindow);
        WindowXY.setBackground(Color.darkGray);
        this.add(WindowXY);
        WindowXY.reshape(10,10,Settings.DRAWAREA_WIDTH,Settings.DRAWAREA_HEIGHT);
    }
    else {
        Window = new DrawArea(itemlist, StatusWindow);
        Window.setBackground(Color.darkGray);
        this.add(Window);
        Window.reshape(10,10,Settings.DRAWAREA_WIDTH,Settings.DRAWAREA_HEIGHT);
    }

}


} // End Main


