package libViewer;

import java.net.*;
import java.awt.*;
import java.io.*;
import java.util.*;

public class Networking {

  static public ItemList processRequest (String URL, String Port, String Functioncode, String data, String reserved, ActionList actionlist, Choice server_choice, TextArea StatusWindow) {

        Action newAction = new Action();

        Main.Lib_loaded = false;
        Main.Nodes_Rep  = false;
        Main.server_status.setText("contacting libServer: " + URL + " / Port " + Port);

        int number_items = 0;
        boolean ok = true;
        int checkAction = 0;

        int shelve_rows    = -1;
        int shelve_columns = -1;
        int curr_x_pos     = -1;
        int curr_y_pos     = 0;
        boolean shelve_rows_flag = false;
        boolean can_write = false;

        ItemList itemlist = null;

        String status_code = "";
        String status_txt  = "";

        Socket socket = null;
        PrintWriter out = null;
        BufferedReader in = null;

        InetAddress host = null;
        try { host = host.getByName(URL); }
        catch (UnknownHostException uhe) {
              StatusWindow.appendText("Couldnt get IP Address for host " + URL);
              ok = false; return (null);
              }

        try {
            socket = new Socket(host, Integer.valueOf(Port).intValue());
            out = new PrintWriter(socket.getOutputStream(), true);
            in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        } catch (UnknownHostException e) {
            StatusWindow.appendText("Don't know about host: " + URL);
            Main.server_status.setText("unknown host.");
            ok = false; return (null);
        } catch (IOException e) {
            StatusWindow.appendText("libServer is not running on host " + URL);
            StatusWindow.appendText("\nPlease contact " + Settings.CONTACT_PERSON);
            Main.server_status.setText("libServer is not running.");
            ok = false; return (null);
        }

        if (ok) {

        Main.server_status.setText("libServer contacted. waiting for reply.....");
        String fromServer = "";
        String Message = "";
        // 1. send function code
        out.println("$SERV_BUT " + Functioncode);
        // 2. send data
        out.println("$SERV_DATA " + data);
        // 3. send reserved data
        out.println("$SERV_RESERVED " + reserved);

        // construct ItemList
        int x = -1;
        int i;

        itemlist = new ItemList();

        try {
        while ((fromServer = in.readLine()) != null) {

               if (Settings.DEBUG) StatusWindow.appendText(fromServer + "\n");
               //System.out.println(fromServer);
               String parseit = "$";                                   // Character for Keywords
               String parm;                                            // buffer for arguments

               if (fromServer.length() > 2) {                          // lines < 3 are useless (at least!)
               if (fromServer.charAt(0) == parseit.charAt(0)) {

               fromServer = fromServer.substring(1);                   // cut - 1. character

               StringTokenizer st = new StringTokenizer(fromServer);   // Separate Arguments

               parm = st.nextToken();                                  // get Keyword
               int words = st.countTokens();

            // .................................................................
            // read shelve description block
            // .................................................................
            if (parm.compareTo("SHELVE_ROWS") == 0) {
                shelve_rows = Integer.valueOf(st.nextToken()).intValue();
                shelve_rows_flag = true;
                System.out.println("s1");
                }
            if (parm.compareTo("SHELVE_COLUMNS") == 0) {
                shelve_columns = Integer.valueOf(st.nextToken()).intValue();
                if (shelve_rows_flag) {
                    if ((shelve_columns > 0) && (shelve_rows > 0)) {
                      itemlist.labels.init_Map(shelve_columns,shelve_rows);
                      itemlist.labels.valid = true;
                      can_write = true;
                System.out.println("s2");
                      }
                    }
                }
            if  (can_write) {

            if (parm.compareTo("SHELVE_LABEL") == 0) {
                curr_x_pos++;
                if (curr_x_pos > itemlist.labels.x_dim - 1) { curr_y_pos++; curr_x_pos = 0; };
                if (curr_y_pos <= itemlist.labels.y_dim - 1) {
                    itemlist.labels.labels[curr_x_pos][curr_y_pos] = "";
                    for (i = 0; i < words; i++) {
                    itemlist.labels.labels[curr_x_pos][curr_y_pos] = itemlist.labels.labels[curr_x_pos][curr_y_pos] + st.nextToken();
                    if (i != words - 1) itemlist.labels.labels[curr_x_pos][curr_y_pos] = itemlist.labels.labels[curr_x_pos][curr_y_pos] + " ";
                  }
                }
              }
            if (parm.compareTo("SHELVE_DESCR") == 0) {
                if (curr_y_pos <= itemlist.labels.y_dim - 1) {
                    itemlist.labels.descr[curr_x_pos][curr_y_pos] = "";
                    for (i = 0; i < words; i++) {
                    itemlist.labels.descr[curr_x_pos][curr_y_pos] = itemlist.labels.descr[curr_x_pos][curr_y_pos] + st.nextToken();
                    if (i != words - 1) itemlist.labels.descr[curr_x_pos][curr_y_pos] = itemlist.labels.descr[curr_x_pos][curr_y_pos] + " ";
                  }
                }
              }
            }
            // .................................................................
               // Receive number of Items
               // ..............................................................
               if (parm.compareTo("ITEMCOUNT") == 0) {
                  number_items = Integer.valueOf(st.nextToken()).intValue();
                  itemlist.init_items(number_items);
                  Main.server_status.setText("receiving data - progress: 0%");
               }
               // ..............................................................
               // Receive Status-Data
               // ..............................................................
               if (parm.compareTo("STATUS_CODE") == 0) {
                   status_code = st.nextToken();
               }
               if (parm.compareTo("STATUS_TXT") == 0) {
                  for (i = 0; i < words; i++) {
                  status_txt = status_txt + st.nextToken();
                  if (i != words - 1) status_txt = status_txt + " ";
               } }
               // ..............................................................
               // Receive Action
               // ..............................................................
               if (parm.compareTo("SERV_URL") == 0) {
                  newAction.URL = st.nextToken();
                  checkAction++;
               }
               if (parm.compareTo("SERV_PORT") == 0) {
                  newAction.Port = st.nextToken();
                  checkAction++;
               }
               if (parm.compareTo("SERV_DESCR") == 0) {
                  checkAction++;
                  for (i = 0; i < words; i++) {
                  newAction.Description = newAction.Description + st.nextToken();
                  if (i != words - 1) newAction.Description = newAction.Description + " ";
               } }
               if (parm.compareTo("SERV_DATA") == 0) {
                  for (i = 0; i < words; i++) {
                  newAction.Data = newAction.Data + st.nextToken();
                  if (i != words - 1) newAction.Data = newAction.Data + " ";
               } }
               if (parm.compareTo("SERV_BUT1") == 0) {
                  newAction.But1 = st.nextToken();
                  checkAction++;
               }
               if (parm.compareTo("SERV_BUT2") == 0) {
                  newAction.But2 = st.nextToken();
               }
               if (parm.compareTo("SERV_BUT1TXT") == 0) {
                  checkAction++;
                  for (i = 0; i < words; i++) {
                  newAction.But1Txt = newAction.But1Txt + st.nextToken();
                  if (i != words - 1) newAction.But1Txt = newAction.But1Txt + " ";
               } }
               if (parm.compareTo("SERV_BUT2TXT") == 0) {
                  for (i = 0; i < words; i++) {
                  newAction.But2Txt = newAction.But2Txt + st.nextToken();
                  if (i != words - 1) newAction.But2Txt = newAction.But2Txt + " ";
               } }
               if (parm.compareTo("SERV_RESERVED") == 0) {
                  for (i = 0; i < words; i++) {
                  newAction.Reserved = newAction.Reserved + st.nextToken();
                  if (i != words - 1) newAction.Reserved = newAction.Reserved + " ";
               } }
               // ..............................................................
               // Receive all Items
               // ..............................................................
               if (parm.compareTo("TITLE") == 0) {
                  x++;
                  float value = (float) x;
                  float number_items_float = (float) number_items;
                  float percent_float = value / (float) (number_items_float / 100);
                  int percent = (int) percent_float;
                  if (percent > 0) Main.server_status.setText("receiving data - progress: " + percent + "%");
                  itemlist.items[x].Key = x;
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].title = itemlist.items[x].title + st.nextToken();
                  if (i != words - 1) itemlist.items[x].title = itemlist.items[x].title + " ";
                } }
                if (parm.compareTo("WIDTH") == 0) {
                  itemlist.items[x].spine_width = Integer.valueOf(st.nextToken()).intValue();
                }
                if (parm.compareTo("HEIGHT") == 0) {
                  itemlist.items[x].spine_height = Integer.valueOf(st.nextToken()).intValue();
                }
                if (parm.compareTo("CREATOR") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].creator = itemlist.items[x].creator + st.nextToken();
                  if (i != words - 1) itemlist.items[x].creator = itemlist.items[x].creator + " ";
                } }
                if (parm.compareTo("SUBJECT") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].subject = itemlist.items[x].subject + st.nextToken();
                  if (i != words - 1) itemlist.items[x].subject = itemlist.items[x].subject + " ";
                } }
                if (parm.compareTo("DESCRIPTION") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].description = itemlist.items[x].description + st.nextToken();
                  if (i != words - 1) itemlist.items[x].description = itemlist.items[x].description + " ";
                } }
                if (parm.compareTo("PUBLISHER") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].publisher = itemlist.items[x].publisher + st.nextToken();
                  if (i != words - 1) itemlist.items[x].publisher = itemlist.items[x].publisher + " ";
                } }
                if (parm.compareTo("CONTRIBUTOR") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].contributor = itemlist.items[x].contributor + st.nextToken();
                  if (i != words - 1) itemlist.items[x].contributor = itemlist.items[x].contributor + " ";
                } }
                if (parm.compareTo("DATE") == 0) {
                  itemlist.items[x].date = st.nextToken();
                }
                if (parm.compareTo("TYPE") == 0) {
                  itemlist.items[x].type = st.nextToken();
                }
                if (parm.compareTo("FORMAT") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].format = itemlist.items[x].format + st.nextToken();
                  if (i != words - 1) itemlist.items[x].format = itemlist.items[x].format + " ";
                } }
                if (parm.compareTo("IDENTIFIER") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].identifier = itemlist.items[x].identifier + st.nextToken();
                  if (i != words - 1) itemlist.items[x].identifier = itemlist.items[x].identifier + " ";
                } }
                if (parm.compareTo("SOURCE") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].source = itemlist.items[x].source + st.nextToken();
                  if (i != words - 1) itemlist.items[x].source = itemlist.items[x].source + " ";
                } }
                if (parm.compareTo("LANGUAGE") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].language = itemlist.items[x].language + st.nextToken();
                  if (i != words - 1) itemlist.items[x].language = itemlist.items[x].language + " ";
                } }
                if (parm.compareTo("RELATION") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].relation = itemlist.items[x].relation + st.nextToken();
                  if (i != words - 1) itemlist.items[x].relation = itemlist.items[x].relation + " ";
                } }
                if (parm.compareTo("COVERAGE") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].coverage = itemlist.items[x].coverage + st.nextToken();
                  if (i != words - 1) itemlist.items[x].coverage = itemlist.items[x].coverage + " ";
                } }
                if (parm.compareTo("RIGHTS") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].rights = itemlist.items[x].rights + st.nextToken();
                  if (i != words - 1) itemlist.items[x].rights = itemlist.items[x].rights + " ";
                } }
                if (parm.compareTo("DOMAIN") == 0) {
                  for (i = 0; i < words; i++) {
                  itemlist.items[x].domain = itemlist.items[x].domain + st.nextToken();
                  if (i != words - 1) itemlist.items[x].domain = itemlist.items[x].domain + " ";
                } }
                if (parm.compareTo("XPOS") == 0) {
                  itemlist.items[x].xpos = Integer.valueOf(st.nextToken()).intValue();
                }
                if (parm.compareTo("YPOS") == 0) {
                  itemlist.items[x].ypos = Integer.valueOf(st.nextToken()).intValue();
                }
                if (parm.compareTo("ZPOS") == 0) {
                  itemlist.items[x].zpos = Float.valueOf(st.nextToken());
                }
                if (parm.compareTo("SIZE_PAGE") == 0) {
                  itemlist.items[x].page_size = Integer.valueOf(st.nextToken()).intValue();
                }
                if (parm.compareTo("SIZE_BYTE") == 0) {
                  itemlist.items[x].byte_size = Integer.valueOf(st.nextToken()).intValue();
                }
                if (parm.compareTo("IMAGE_LOGO") == 0) {
                  String Logo_Shortname = st.nextToken();
                  int k;
                  for (k=0; k < Main.logos.number_rows; k++) {
                      if (Main.logos.row[k].Logo_Shortname.compareTo(Logo_Shortname) == 0) {
                      itemlist.items[x].Logo = Main.logos.row[k].Logo;
                      itemlist.items[x].Logo_available = true;
                      }
                  }
                }
                if (parm.compareTo("TEMPLATE") == 0) {
                  itemlist.items[x].datatype = st.nextToken();
                }
                if (parm.compareTo("WELLTHUMBED") == 0) {
                  String wellthumbed = st.nextToken();
                  if (wellthumbed.compareTo("0") != 0) itemlist.items[x].wellthumbed = true;
                }
                if (parm.compareTo("DUST_LEVEL") == 0) {
                  itemlist.items[x].dust_level = Integer.valueOf(st.nextToken()).intValue();
                }
                if (parm.compareTo("COLOR_FRONT") == 0) {
                if (words == 3) {
                  int red   = Integer.valueOf(st.nextToken()).intValue();
                  int green = Integer.valueOf(st.nextToken()).intValue();
                  int blue  = Integer.valueOf(st.nextToken()).intValue();
                  itemlist.items[x].surface_color = new Color (red, green, blue);
                  }
                else StatusWindow.appendText("WARNING: Invalid Color detected: $" + fromServer + "\n");
                }
                if (parm.compareTo("COLOR_TOP") == 0) {
                if (words == 3) {
                  int red   = Integer.valueOf(st.nextToken()).intValue();
                  int green = Integer.valueOf(st.nextToken()).intValue();
                  int blue  = Integer.valueOf(st.nextToken()).intValue();
                  itemlist.items[x].surface_color2 = new Color (red, green, blue);
                  }
                else StatusWindow.appendText("WARNING: Invalid Color detected: $" + fromServer + "\n");
                }
                if (parm.compareTo("COLOR_SPINE") == 0) {
                if (words == 3) {
                  int red   = Integer.valueOf(st.nextToken()).intValue();
                  int green = Integer.valueOf(st.nextToken()).intValue();
                  int blue  = Integer.valueOf(st.nextToken()).intValue();
                  itemlist.items[x].spine_color = new Color (red, green, blue);
                  }
                else StatusWindow.appendText("WARNING: Invalid Color detected: $" + fromServer + "\n");
                }
                if (parm.compareTo("COLOR_TITLE") == 0) {
                if (words == 3) {
                  int red   = Integer.valueOf(st.nextToken()).intValue();
                  int green = Integer.valueOf(st.nextToken()).intValue();
                  int blue  = Integer.valueOf(st.nextToken()).intValue();
                  itemlist.items[x].title_color = new Color (red, green, blue);
                  }
                else StatusWindow.appendText("WARNING: Invalid Color detected: $" + fromServer + "\n");
                }
                if (parm.compareTo("COLOR_CREATOR") == 0) {
                if (words == 3) {
                  int red   = Integer.valueOf(st.nextToken()).intValue();
                  int green = Integer.valueOf(st.nextToken()).intValue();
                  int blue  = Integer.valueOf(st.nextToken()).intValue();
                  itemlist.items[x].creator_color = new Color (red, green, blue);
                  }
                else StatusWindow.appendText("WARNING: Invalid Color detected: $" + fromServer + "\n");
                }
                if (parm.compareTo("HIGHLIGHTING") == 0) {
                  String highlighting = st.nextToken();
                  if (highlighting.compareTo("1") == 0) itemlist.items[x].highlighting = true;
                }
          }}
        }// end while

        } catch (IOException io) { return (null); };
        x++;
        itemlist.number_items = x;

        }

    if ((ok) && (status_code.compareTo("3") != 0)) {
              StatusWindow.appendText("\n" + status_txt);
              Main.server_status.setText(status_txt);
              Main.Lib_loaded = true;
              }
    if (status_code.compareTo("3") == 0) {
              StatusWindow.appendText("\n" + status_txt);
              Main.server_status.setText(status_txt);
              }

    if (checkAction == 5) {
        actionlist.addAction();
        Action currentAction = (Action) actionlist.Items.lastElement();
        currentAction.URL = newAction.URL;
        currentAction.Port = newAction.Port;
        currentAction.Data = newAction.Data;
        currentAction.Description = newAction.Description;
        currentAction.But1 = newAction.But1;
        currentAction.But2 = newAction.But2;
        currentAction.But1Txt = newAction.But1Txt;
        currentAction.But2Txt = newAction.But2Txt;
        currentAction.Reserved = newAction.Reserved;
        server_choice.addItem(currentAction.Description);
        }

    if (ok) {

    try { out.close(); } catch (Exception e) { System.out.println("Close OUT-Channel failed.");}
    try { in.close(); } catch (Exception e) { System.out.println("Close IN-Channel failed.");}
    try { socket.close(); } catch (Exception e) { System.out.println("Close Server socket failed.");}

    }
    
    check_xy_parameters(itemlist, StatusWindow);
    return itemlist;
    
  }
//------------------------------------------------------------------------------
public static void check_xy_parameters (ItemList itemlist, TextArea StatusWindow) {
  boolean valid = true;
  boolean found = false;
  int i = 0;
  for (i = 0; i < itemlist.number_items; i++) {
      if (itemlist.items[i].xpos == -1) valid = false;
      else found = true;
      if (itemlist.items[i].ypos == -1) valid = false;
      else found = true;
      }
  if ((valid) && (itemlist.number_items != 0)) { itemlist.xy_params_valid = true; }
  else {
          if (found) StatusWindow.appendText("INFO: Check x/y Parameters! Shelve Representation is not available.");
       }
}

}